<template>
  <div id="main">
    <!-- LOADER -->
    <div v-if="!isReady" class="text-center">
      <IconLoader id="loader" />
      <h2 class="mt-2">Loading...</h2>
    </div>

    <div v-else>
      <div v-if="!errorMessage">
        <!-- PAYED - CHECK MARK -->
        <div v-if="tip?.payment?.payed" id="checkmark">
          <LottieAnimation
            path="img/anim/checkmark.json"
            :width="150"
            :height="150"
            :loop="false"
          />
          <p class="text-muted ps-3">
            <span class="text-success h3">
              {{ (tip?.payment?.amount || 0) / 1000 }} </span
            >&nbsp;sats
          </p>
          <p class="ps-3">
            <span class="fw-bold">{{ tip?.profile?.displayName }}</span>
            thanks You 🙏
          </p>
        </div>

        <!-- BODY -->
        <div v-else>
          <TitleIcon id="icon" :showTitle="true" />

          <!-- TITLE & USER -->
          <img class="avatar mt-4" :src="userImgUrl" />
          <h2 class="mt-1">
            Send tip to
            <span class="fw-bold">{{ tip?.profile?.displayName }}</span>
          </h2>

          <!-- CONTENT name -->
          <div
            class="d-flex flex-row justify-content-center text-start mx-3 mt-3"
          >
            <img
              class="img-platform align-self-start me-2"
              :src="platformImgUrl"
            />
            <div>
              <p class="content-title lines-max-1">{{ tip?.content?.title }}</p>
              <p class="content-desc lines-max-2">
                {{ tip.content.description }}
              </p>
            </div>
          </div>

          <!-- QR Code & Payment req -->
          <QrCode class="mt-3" :value="tip?.payment?.payReq" />

          <CopyableText :text="tip?.payment?.payReq" />
        </div>
      </div>
      <!-- ERROR -->
      <div v-else class="mt-5">
        <Alert :message="errorMessage" :type="errorType" :light="true" />
      </div>
    </div>
  </div>
</template>

<script>
import Alert from "../components/Alert.vue";
import IconLoader from "../components/IconLoader.vue";
import QrCode from "../components/QrCode.vue";
import TitleIcon from "../components/TitleIcon.vue";
import UserError from "../errors/UserError";
import LottieAnimation from "lottie-vuejs/src/LottieAnimation.vue";
import CopyableText from '../components/CopyableText.vue';

export default {
  components: { QrCode, TitleIcon, IconLoader, Alert, LottieAnimation, CopyableText },
  data() {
    return {
      isReady: false,
      errorMessage: "",
      errorType: "error",
    };
  },
  computed: {
    tip() {
      return this.$store.state.tips.tip;
    },
    userImgUrl() {
      return process.env.VUE_APP_API_URL + this.tip.user?.imgUrl;
    },
    platformImgUrl() {
      return `${process.env.VUE_APP_API_URL}/files/img/platform/${this.tip.platform}.svg`;
    },
  },
  async beforeCreate() {
    try {
      document.body.className = "tip";

      if (
        this.$route.query &&
        this.$route.query.id &&
        this.$route.query.platform
      ) {
        var extra = Object.assign({}, this.$route.query);
        delete extra.id;
        delete extra.platform;

        this.$store
          .dispatch("addPlatformTip", {
            contentPublicId: this.$route.query.id,
            platform: this.$route.query.platform,
            extraData: extra,
          })
          .then(() => {
            this.isReady = true;
            this.checkPayment();
          })
          .catch((err) => this.showError(err));
      } else {
        this.showError(
          new UserError("Query parametr id and platform is required")
        );
      }
    } catch (err) {
      this.showError(err);
    }
  },
  methods: {
    checkPayment() {
      this.$store.dispatch("checkTipPayment");
    },
    showError(err) {
      console.log(err);
      this.errorMessage =
        err.viewable && err.message
          ? err.message
          : "Unexpected error occured. Try it again.";
      this.errorType = err.type ? err.type : this.errorType;
      this.isReady = true;
    },
  },
};
</script>

<style lang="scss">
body.tip {
  background-color: #3b3b3b;
}

#main {
  background-color: #3b3b3b;
  width: 400px;
  max-width: 100%;
  height: fit-content;
  min-height: 650px;
  padding: 20px 25px;
  color: white;
  text-align: center;
}

#loader {
  width: 60px;
  margin: 25vh auto 0 auto;
}

#icon {
  position: absolute;
  font-size: 1.4em;
}

#checkmark {
  margin-top: 25vh;
}

.avatar {
  color: black;
  background-color: white;
  border-radius: 50%;
  width: 70px;
  padding: 4px;
}

.img-platform {
  width: 30px;
}

.content-title {
  font-weight: 600;
  font-size: 1.1em;
}

.content-desc {
  color: $gray-200;
}

#pay-req {
  cursor: pointer;
  word-wrap: break-word;
}

#pay-req:hover {
  color: #858585 !important;
}
</style>